<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "certifying_body".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CertifyingBody".
 *
 * Columns in table "certifying_body" available as properties of the model,
 * followed by relations of table "certifying_body" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $full_name
 * @property string $abbreviation
 *
 * @property CertificationSpecialty[] $certificationSpecialties
 * @property CertificationSubSpecialty[] $certificationSubSpecialties
 * @property ProviderCertification[] $providerCertifications
 */
abstract class BaseCertifyingBody extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'certifying_body';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CertifyingBody|CertifyingBodies', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name', 'required'),
            array('name', 'length', 'max' => 50),
            array('full_name', 'length', 'max' => 100),
            array('abbreviation', 'length', 'max' => 5),
            array('full_name, abbreviation', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, full_name, abbreviation', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'certificationSpecialties' => array(self::HAS_MANY, 'CertificationSpecialty', 'certifying_body_id'),
            'certificationSubSpecialties' => array(self::HAS_MANY, 'CertificationSubSpecialty', 'certifying_body_id'),
            'providerCertifications' => array(self::HAS_MANY, 'ProviderCertification', 'certifying_body_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'full_name' => Yii::t('app', 'Full Name'),
            'abbreviation' => Yii::t('app', 'Abbreviation'),
            'certificationSpecialties' => null,
            'certificationSubSpecialties' => null,
            'providerCertifications' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('full_name', $this->full_name, true);
        $criteria->compare('abbreviation', $this->abbreviation, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
